package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[MsgAccount] 数据对象
 */
@TableName(value = "T_SRFMSGACCOUNT",resultMap = "MsgAccountResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class MsgAccount extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    @TableLogic(value= "1",delval="0")//设定逻辑有效属性
    @TableField(fill = FieldFill.INSERT)
    private Integer enable;
    private String foldermodel;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer islist;
    private String mailaddress;
    private String mobile;
    @TableId(value= "msgaccountid",type=IdType.UUID)//指定主键生成策略
    private String msgaccountid;
    private String msgaccountname;
    private String msgaddress;
    private String msnemail;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wecharaddr;
    private String wxaddr;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[逻辑有效标志]
     *  @param enable
     */
    public void setEnable(Integer enable){
        this.enable = enable;
        this.set("enabledirtyflag",true);
    }
    /**
     *  获取属性值[逻辑有效标志]
     */
    public Integer getEnable(){
        if(StringUtils.isEmpty(enable))
        {
            this.enable = 1;//设置逻辑有效值
            this.set("enabledirtyflag",true);
        }
        return this.enable;
    }
    /**
     *  重置属性值[逻辑有效标志]
     */
    public void resetEnable(){
        this.set("enabledirtyflag",false);
        this.enable = null;
    }
    /**
     *  设置属性值[目录模型]
     *  @param foldermodel
     */
    public void setFoldermodel(String foldermodel){
        if(StringUtils.isEmpty(foldermodel))
            foldermodel=null;
        this.foldermodel = foldermodel;
        this.set("foldermodeldirtyflag",true);
    }
    /**
     *  获取属性值[目录模型]
     */
    public String getFoldermodel(){
        return this.foldermodel;
    }
    /**
     *  重置属性值[目录模型]
     */
    public void resetFoldermodel(){
        this.set("foldermodeldirtyflag",false);
        this.foldermodel = null;
    }
    /**
     *  设置属性值[消息账户组]
     *  @param islist
     */
    public void setIslist(Integer islist){
        this.islist = islist;
        this.set("islistdirtyflag",true);
    }
    /**
     *  获取属性值[消息账户组]
     */
    public Integer getIslist(){
        return this.islist;
    }
    /**
     *  重置属性值[消息账户组]
     */
    public void resetIslist(){
        this.set("islistdirtyflag",false);
        this.islist = null;
    }
    /**
     *  设置属性值[邮件地址]
     *  @param mailaddress
     */
    public void setMailaddress(String mailaddress){
        if(StringUtils.isEmpty(mailaddress))
            mailaddress=null;
        this.mailaddress = mailaddress;
        this.set("mailaddressdirtyflag",true);
    }
    /**
     *  获取属性值[邮件地址]
     */
    public String getMailaddress(){
        return this.mailaddress;
    }
    /**
     *  重置属性值[邮件地址]
     */
    public void resetMailaddress(){
        this.set("mailaddressdirtyflag",false);
        this.mailaddress = null;
    }
    /**
     *  设置属性值[移动电话]
     *  @param mobile
     */
    public void setMobile(String mobile){
        if(StringUtils.isEmpty(mobile))
            mobile=null;
        this.mobile = mobile;
        this.set("mobiledirtyflag",true);
    }
    /**
     *  获取属性值[移动电话]
     */
    public String getMobile(){
        return this.mobile;
    }
    /**
     *  重置属性值[移动电话]
     */
    public void resetMobile(){
        this.set("mobiledirtyflag",false);
        this.mobile = null;
    }
    /**
     *  设置属性值[消息账户标识]
     *  @param msgaccountid
     */
    public void setMsgaccountid(String msgaccountid){
        if(StringUtils.isEmpty(msgaccountid))
            msgaccountid=null;
        this.msgaccountid = msgaccountid;
        this.set("msgaccountiddirtyflag",true);
    }
    /**
     *  获取属性值[消息账户标识]
     */
    public String getMsgaccountid(){
        return this.msgaccountid;
    }
    /**
     *  重置属性值[消息账户标识]
     */
    public void resetMsgaccountid(){
        this.set("msgaccountiddirtyflag",false);
        this.msgaccountid = null;
    }
    /**
     *  设置属性值[消息账户名称]
     *  @param msgaccountname
     */
    public void setMsgaccountname(String msgaccountname){
        if(StringUtils.isEmpty(msgaccountname))
            msgaccountname=null;
        this.msgaccountname = msgaccountname;
        this.set("msgaccountnamedirtyflag",true);
    }
    /**
     *  获取属性值[消息账户名称]
     */
    public String getMsgaccountname(){
        return this.msgaccountname;
    }
    /**
     *  重置属性值[消息账户名称]
     */
    public void resetMsgaccountname(){
        this.set("msgaccountnamedirtyflag",false);
        this.msgaccountname = null;
    }
    /**
     *  设置属性值[地址]
     *  @param msgaddress
     */
    public void setMsgaddress(String msgaddress){
        if(StringUtils.isEmpty(msgaddress))
            msgaddress=null;
        this.msgaddress = msgaddress;
        this.set("msgaddressdirtyflag",true);
    }
    /**
     *  获取属性值[地址]
     */
    public String getMsgaddress(){
        return this.msgaddress;
    }
    /**
     *  重置属性值[地址]
     */
    public void resetMsgaddress(){
        this.set("msgaddressdirtyflag",false);
        this.msgaddress = null;
    }
    /**
     *  设置属性值[MSN邮件地址]
     *  @param msnemail
     */
    public void setMsnemail(String msnemail){
        if(StringUtils.isEmpty(msnemail))
            msnemail=null;
        this.msnemail = msnemail;
        this.set("msnemaildirtyflag",true);
    }
    /**
     *  获取属性值[MSN邮件地址]
     */
    public String getMsnemail(){
        return this.msnemail;
    }
    /**
     *  重置属性值[MSN邮件地址]
     */
    public void resetMsnemail(){
        this.set("msnemaildirtyflag",false);
        this.msnemail = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[微信地址]
     *  @param wecharaddr
     */
    public void setWecharaddr(String wecharaddr){
        if(StringUtils.isEmpty(wecharaddr))
            wecharaddr=null;
        this.wecharaddr = wecharaddr;
        this.set("wecharaddrdirtyflag",true);
    }
    /**
     *  获取属性值[微信地址]
     */
    public String getWecharaddr(){
        return this.wecharaddr;
    }
    /**
     *  重置属性值[微信地址]
     */
    public void resetWecharaddr(){
        this.set("wecharaddrdirtyflag",false);
        this.wecharaddr = null;
    }
    /**
     *  设置属性值[微信地址]
     *  @param wxaddr
     */
    public void setWxaddr(String wxaddr){
        if(StringUtils.isEmpty(wxaddr))
            wxaddr=null;
        this.wxaddr = wxaddr;
        this.set("wxaddrdirtyflag",true);
    }
    /**
     *  获取属性值[微信地址]
     */
    public String getWxaddr(){
        return this.wxaddr;
    }
    /**
     *  重置属性值[微信地址]
     */
    public void resetWxaddr(){
        this.set("wxaddrdirtyflag",false);
        this.wxaddr = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetEnable();
        resetFoldermodel();
        resetIslist();
        resetMailaddress();
        resetMobile();
        resetMsgaccountid();
        resetMsgaccountname();
        resetMsgaddress();
        resetMsnemail();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetWecharaddr();
        resetWxaddr();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public MsgAccount copyTo(MsgAccount targetEntity)
	{
		BeanCopier copier=BeanCopier.create(MsgAccount.class, MsgAccount.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetMsgaccountid();
		return targetEntity;
	}
}